﻿Broker_NameToggle = LibStub("AceAddon-3.0"):NewAddon("Broker_NameToggle")

local NT = Broker_NameToggle
local QTip = LibStub('LibQTip-1.0')

local L = LibStub("AceLocale-3.0"):GetLocale("Broker_NameToggle")

toggleCVars = {
			["cats"] = {
				"Players",
				"NPCs",
				"Nameplates",
			},
			["Players"] = {
				"UnitNameFriendlyPlayerName",
				"UnitNamePlayerGuild",
				"UnitNamePlayerPVPTitle",
				"UnitNameOwn",
				"UnitNameEnemyPlayerName",
			},
			["NPCs"] = {
				"UnitNameNPC",
				"UnitNameNonCombatCreatureName",
				"UnitNameFriendlyPetName",
				"UnitNameFriendlyGuardianName",
				"UnitNameFriendlyTotemName",
				"UnitNameEnemyPetName",
				"UnitNameEnemyGuardianName",
				"UnitNameEnemyTotemName",
			},
			["Nameplates"] = {
				"nameplateShowFriends",
				"nameplateShowEnemies",
			},
		}
				

Broker_NameToggle.obj = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_NameToggle", {
	type = "data source",
	icon = "Interface\\Icons\\Ability_Hunter_Pathfinding",
	label = "NameToggle",
	text = "NameToggle",
	OnEnter = function(frame)
			local tooltip = QTip:Acquire("Broker_NameToggle_Tooltip", 2, "LEFT", "RIGHT")
			tooltip:Clear()
			tooltip:SmartAnchorTo(frame)
			tooltip:SetAutoHideDelay(0.1, frame)
			NT.tooltip = tooltip
			NT:ShowTooltip()
		end,
	OnClick = function(frame,button)
			if button=="LeftButton" then
				if IsShiftKeyDown() then
					NT:Toggle("UnitNameNPC")
				elseif IsControlKeyDown() then
					NT:Toggle("UnitNameOwn")
				elseif IsAltKeyDown() then
					NT:Toggle("UnitNameEnemyPlayerName")
				else
					NT:Toggle("UnitNameFriendlyPlayerName")
				end
			end
		NT:ShowTooltip()
		end,
	}
)

local function ToggleTooltip(var)
	SetCVar(var._OnMouseDown_arg.Var, GetCVar(var._OnMouseDown_arg.Var) == "1" and 0 or 1)
	NT.tooltip:SetCell(var._OnMouseDown_arg.line,2,GetCVarBool(var._OnMouseDown_arg.Var) and L["shown"] or L["hidden"])
end

function NT:Toggle(var)
	SetCVar(var, GetCVar(var) == "1" and 0 or 1)
end

function NT:ShowTooltip()
	local tooltip = self.tooltip
	tooltip:Clear()
	tooltip:AddHeader("Broker NameToggle")
	foreach (toggleCVars["cats"], function(index,cat)
		tooltip:AddSeparator()
		tooltip:AddLine("|cffffff00"..L[cat].."|r")
		foreach (toggleCVars[cat], function(index2, CVar)
			local y = tooltip:AddLine(L[CVar],GetCVarBool(CVar) and L["shown"] or L["hidden"])
			tooltip:SetLineScript(y,"OnMouseDown",ToggleTooltip,{Var=CVar,line=y})
		end)
	end)
	tooltip:AddSeparator()
	tooltip:AddLine()
	tooltip:AddLine("|cff00ff00"..L["hint"].."|r")
	tooltip:AddLine()
	tooltip:Show()
end
